import { PostgrestSingleResponse, PostgrestMaybeSingleResponse, PostgrestResponse } from '@supabase/supabase-js';

declare const DEFAULT_SCHEMA_NAME = "default";

declare type PostgrestPaginationCacheData<Type> = Type[][];
declare type PostgrestCacheData<Type> = Pick<PostgrestSingleResponse<Type>, "data"> | Pick<PostgrestMaybeSingleResponse<Type>, "data"> | Pick<PostgrestResponse<Type>, "data" | "count"> | PostgrestPaginationCacheData<Type>;
declare const isPaginationCacheData: <Type>(data: PostgrestCacheData<Type>) => data is PostgrestPaginationCacheData<Type>;
declare type RevalidateTableOpt = {
    schema?: string;
    table: string;
};
declare type RevalidateRelationOpt<Type> = {
    schema?: string;
    relation: string;
    relationIdColumn: string;
    fKeyColumn: keyof Type;
};
declare type PostgrestMutatorOpts<Type> = {
    /**
     * Will set all keys of the tables to stale
     */
    revalidateTables?: RevalidateTableOpt[];
    /**
     * Will set all keys of the tables where relation.primaryKey === myObj.fKey
     */
    revalidateRelations?: RevalidateRelationOpt<Type>[];
    schema?: string;
};

export { DEFAULT_SCHEMA_NAME, PostgrestCacheData, PostgrestMutatorOpts, RevalidateRelationOpt, RevalidateTableOpt, isPaginationCacheData };
